diff --git a/orocos_kdl/config/cmakemoduleslegacy/GenerateExportHeader.cmake b/orocos_kdl/config/cmakemoduleslegacy/GenerateExportHeader.cmake
new file mode 100644
index 0000000..96044c6
--- /dev/null
+++ b/orocos_kdl/config/cmakemoduleslegacy/GenerateExportHeader.cmake
@@ -0,0 +1,408 @@
+# - Function for generation of export macros for libraries
+# This module provides the function GENERATE_EXPORT_HEADER() and the
+# accompanying ADD_COMPILER_EXPORT_FLAGS() function.
+#
+# The GENERATE_EXPORT_HEADER function can be used to generate a file suitable
+# for preprocessor inclusion which contains EXPORT macros to be used in
+# library classes.
+#
+# GENERATE_EXPORT_HEADER( LIBRARY_TARGET
+#             [BASE_NAME <base_name>]
+#             [EXPORT_MACRO_NAME <export_macro_name>]
+#             [EXPORT_FILE_NAME <export_file_name>]
+#             [DEPRECATED_MACRO_NAME <deprecated_macro_name>]
+#             [NO_EXPORT_MACRO_NAME <no_export_macro_name>]
+#             [STATIC_DEFINE <static_define>]
+#             [NO_DEPRECATED_MACRO_NAME <no_deprecated_macro_name>]
+#             [DEFINE_NO_DEPRECATED]
+#             [PREFIX_NAME <prefix_name>]
+# )
+#
+# ADD_COMPILER_EXPORT_FLAGS( [<output_variable>] )
+#
+# By default GENERATE_EXPORT_HEADER() generates macro names in a file name
+# determined by the name of the library. The ADD_COMPILER_EXPORT_FLAGS function
+# adds -fvisibility=hidden to CMAKE_CXX_FLAGS if supported, and is a no-op on
+# Windows which does not need extra compiler flags for exporting support. You
+# may optionally pass a single argument to ADD_COMPILER_EXPORT_FLAGS that will
+# be populated with the required CXX_FLAGS required to enable visibility support
+# for the compiler/architecture in use.
+#
+# This means that in the simplest case, users of these functions will be
+# equivalent to:
+#
+#   add_compiler_export_flags()
+#   add_library(somelib someclass.cpp)
+#   generate_export_header(somelib)
+#   install(TARGETS somelib DESTINATION ${LIBRARY_INSTALL_DIR})
+#   install(FILES
+#    someclass.h
+#    ${PROJECT_BINARY_DIR}/somelib_export.h DESTINATION ${INCLUDE_INSTALL_DIR}
+#   )
+#
+# And in the ABI header files:
+#
+#   #include "somelib_export.h"
+#   class SOMELIB_EXPORT SomeClass {
+#     ...
+#   };
+#
+# The CMake fragment will generate a file in the ${CMAKE_CURRENT_BUILD_DIR}
+# called somelib_export.h containing the macros SOMELIB_EXPORT, SOMELIB_NO_EXPORT,
+# SOMELIB_DEPRECATED, SOMELIB_DEPRECATED_EXPORT and SOMELIB_DEPRECATED_NO_EXPORT.
+# The resulting file should be installed with other headers in the library.
+#
+# The BASE_NAME argument can be used to override the file name and the names
+# used for the macros
+#
+#   add_library(somelib someclass.cpp)
+#   generate_export_header(somelib
+#     BASE_NAME other_name
+#   )
+#
+# Generates a file called other_name_export.h containing the macros
+# OTHER_NAME_EXPORT, OTHER_NAME_NO_EXPORT and OTHER_NAME_DEPRECATED etc.
+#
+# The BASE_NAME may be overridden by specifiying other options in the function.
+# For example:
+#
+#   add_library(somelib someclass.cpp)
+#   generate_export_header(somelib
+#     EXPORT_MACRO_NAME OTHER_NAME_EXPORT
+#   )
+#
+# creates the macro OTHER_NAME_EXPORT instead of SOMELIB_EXPORT, but other macros
+# and the generated file name is as default.
+#
+#   add_library(somelib someclass.cpp)
+#   generate_export_header(somelib
+#     DEPRECATED_MACRO_NAME KDE_DEPRECATED
+#   )
+#
+# creates the macro KDE_DEPRECATED instead of SOMELIB_DEPRECATED.
+#
+# If LIBRARY_TARGET is a static library, macros are defined without values.
+#
+# If the same sources are used to create both a shared and a static library, the
+# uppercased symbol ${BASE_NAME}_STATIC_DEFINE should be used when building the
+# static library
+#
+#   add_library(shared_variant SHARED ${lib_SRCS})
+#   add_library(static_variant ${lib_SRCS})
+#   generate_export_header(shared_variant BASE_NAME libshared_and_static)
+#   set_target_properties(static_variant PROPERTIES
+#     COMPILE_FLAGS -DLIBSHARED_AND_STATIC_STATIC_DEFINE)
+#
+# This will cause the export macros to expand to nothing when building the
+# static library.
+#
+# If DEFINE_NO_DEPRECATED is specified, then a macro ${BASE_NAME}_NO_DEPRECATED
+# will be defined
+# This macro can be used to remove deprecated code from preprocessor output.
+#
+#   option(EXCLUDE_DEPRECATED "Exclude deprecated parts of the library" FALSE)
+#   if (EXCLUDE_DEPRECATED)
+#     set(NO_BUILD_DEPRECATED DEFINE_NO_DEPRECATED)
+#   endif()
+#   generate_export_header(somelib ${NO_BUILD_DEPRECATED})
+#
+# And then in somelib:
+#
+#   class SOMELIB_EXPORT SomeClass
+#   {
+#   public:
+#   #ifndef SOMELIB_NO_DEPRECATED
+#     SOMELIB_DEPRECATED void oldMethod();
+#   #endif
+#   };
+#
+#   #ifndef SOMELIB_NO_DEPRECATED
+#   void SomeClass::oldMethod() {  }
+#   #endif
+#
+# If PREFIX_NAME is specified, the argument will be used as a prefix to all
+# generated macros.
+#
+# For example:
+#
+#   generate_export_header(somelib PREFIX_NAME VTK_)
+#
+# Generates the macros VTK_SOMELIB_EXPORT etc.
+
+#=============================================================================
+# Copyright 2011 Stephen Kelly <steveire@gmail.com>
+#
+# Distributed under the OSI-approved BSD License (the "License");
+# see accompanying file Copyright.txt for details.
+#
+# This software is distributed WITHOUT ANY WARRANTY; without even the
+# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the License for more information.
+#=============================================================================
+# (To distribute this file outside of CMake, substitute the full
+#  License text for the above reference.)
+# CMake - Cross Platform Makefile Generator
+# Copyright 2000-2011 Kitware, Inc., Insight Software Consortium
+# All rights reserved.
+# 
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 
+# * Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# 
+# * Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# 
+# * Neither the names of Kitware, Inc., the Insight Software Consortium,
+#   nor the names of their contributors may be used to endorse or promote
+#   products derived from this software without specific prior written
+#   permission.
+
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# 
+# ------------------------------------------------------------------------------
+# 
+# The above copyright and license notice applies to distributions of
+# CMake in source and binary form.  Some source files contain additional
+# notices of original copyright by their contributors; see each source
+# for details.  Third-party software packages supplied with CMake under
+# compatible licenses provide their own copyright notices documented in
+# corresponding subdirectories.
+# 
+# ------------------------------------------------------------------------------
+# 
+# CMake was initially developed by Kitware with the following sponsorship:
+# 
+#  * National Library of Medicine at the National Institutes of Health
+#    as part of the Insight Segmentation and Registration Toolkit (ITK).
+# 
+#  * US National Labs (Los Alamos, Livermore, Sandia) ASC Parallel
+#    Visualization Initiative.
+# 
+#  * National Alliance for Medical Image Computing (NAMIC) is funded by the
+#    National Institutes of Health through the NIH Roadmap for Medical Research,
+#    Grant U54 EB005149.
+# 
+#  * Kitware, Inc.
+# 
+
+include(CMakeParseArguments)
+include(CheckCXXCompilerFlag)
+
+# TODO: Install this macro separately?
+macro(_check_cxx_compiler_attribute _ATTRIBUTE _RESULT)
+  check_cxx_source_compiles("${_ATTRIBUTE} int somefunc() { return 0; }
+    int main() { return somefunc();}" ${_RESULT}
+  )
+endmacro()
+
+macro(_test_compiler_hidden_visibility)
+
+  if(CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.2")
+    set(GCC_TOO_OLD TRUE)
+    message(WARNING "GCC version older than 4.2")
+  elseif(CMAKE_COMPILER_IS_GNUC AND CMAKE_C_COMPILER_VERSION VERSION_LESS "4.2")
+    set(GCC_TOO_OLD TRUE)
+    message(WARNING "GCC version older than 4.2")
+  elseif(CMAKE_CXX_COMPILER_ID MATCHES Intel AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "12.0")
+    set(_INTEL_TOO_OLD TRUE)
+    message(WARNING "Intel compiler older than 12.0")
+  endif()
+
+
+  # Exclude XL here because it misinterprets -fvisibility=hidden even though
+  # the check_cxx_compiler_flag passes
+  # http://www.cdash.org/CDash/testDetails.php?test=109109951&build=1419259
+  if(NOT GCC_TOO_OLD
+      AND NOT _INTEL_TOO_OLD
+      AND NOT WIN32
+      AND NOT CYGWIN
+      AND NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES XL
+      AND NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES PGI
+      AND NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES Watcom)
+    check_cxx_compiler_flag(-fvisibility=hidden COMPILER_HAS_HIDDEN_VISIBILITY)
+    check_cxx_compiler_flag(-fvisibility-inlines-hidden
+      COMPILER_HAS_HIDDEN_INLINE_VISIBILITY)
+    option(USE_COMPILER_HIDDEN_VISIBILITY
+      "Use HIDDEN visibility support if available." ON)
+    mark_as_advanced(USE_COMPILER_HIDDEN_VISIBILITY)
+  endif()
+endmacro()
+
+macro(_test_compiler_has_deprecated)
+  if("${CMAKE_CXX_COMPILER_ID}" MATCHES Borland
+      OR "${CMAKE_CXX_COMPILER_ID}" MATCHES HP
+      OR GCC_TOO_OLD
+      OR "${CMAKE_CXX_COMPILER_ID}" MATCHES PGI
+      OR "${CMAKE_CXX_COMPILER_ID}" MATCHES Watcom)
+    set(COMPILER_HAS_DEPRECATED "" CACHE INTERNAL
+      "Compiler support for a deprecated attribute")
+  else()
+    _check_cxx_compiler_attribute("__attribute__((__deprecated__))"
+      COMPILER_HAS_DEPRECATED_ATTR)
+    if(COMPILER_HAS_DEPRECATED_ATTR)
+      set(COMPILER_HAS_DEPRECATED "${COMPILER_HAS_DEPRECATED_ATTR}"
+        CACHE INTERNAL "Compiler support for a deprecated attribute")
+    else()
+      _check_cxx_compiler_attribute("__declspec(deprecated)"
+        COMPILER_HAS_DEPRECATED)
+    endif()
+  endif()
+endmacro()
+
+get_filename_component(_GENERATE_EXPORT_HEADER_MODULE_DIR
+  "${CMAKE_CURRENT_LIST_FILE}" PATH)
+
+macro(_DO_SET_MACRO_VALUES TARGET_LIBRARY)
+  set(DEFINE_DEPRECATED)
+  set(DEFINE_EXPORT)
+  set(DEFINE_IMPORT)
+  set(DEFINE_NO_EXPORT)
+
+  if (COMPILER_HAS_DEPRECATED_ATTR)
+    set(DEFINE_DEPRECATED "__attribute__ ((__deprecated__))")
+  elseif(COMPILER_HAS_DEPRECATED)
+    set(DEFINE_DEPRECATED "__declspec(deprecated)")
+  endif()
+
+  get_property(type TARGET ${TARGET_LIBRARY} PROPERTY TYPE)
+
+  if(NOT ${type} STREQUAL "STATIC_LIBRARY")
+    if(WIN32)
+      set(DEFINE_EXPORT "__declspec(dllexport)")
+      set(DEFINE_IMPORT "__declspec(dllimport)")
+    elseif(COMPILER_HAS_HIDDEN_VISIBILITY AND USE_COMPILER_HIDDEN_VISIBILITY)
+      set(DEFINE_EXPORT "__attribute__((visibility(\"default\")))")
+      set(DEFINE_IMPORT "__attribute__((visibility(\"default\")))")
+      set(DEFINE_NO_EXPORT "__attribute__((visibility(\"hidden\")))")
+    endif()
+  endif()
+endmacro()
+
+macro(_DO_GENERATE_EXPORT_HEADER TARGET_LIBRARY)
+  # Option overrides
+  set(options DEFINE_NO_DEPRECATED)
+  set(oneValueArgs PREFIX_NAME BASE_NAME EXPORT_MACRO_NAME EXPORT_FILE_NAME
+    DEPRECATED_MACRO_NAME NO_EXPORT_MACRO_NAME STATIC_DEFINE
+    NO_DEPRECATED_MACRO_NAME)
+  set(multiValueArgs)
+
+  cmake_parse_arguments(_GEH "${options}" "${oneValueArgs}" "${multiValueArgs}"
+    ${ARGN})
+
+  set(BASE_NAME "${TARGET_LIBRARY}")
+
+  if(_GEH_BASE_NAME)
+    set(BASE_NAME ${_GEH_BASE_NAME})
+  endif()
+
+  string(TOUPPER ${BASE_NAME} BASE_NAME_UPPER)
+  string(TOLOWER ${BASE_NAME} BASE_NAME_LOWER)
+
+  # Default options
+  set(EXPORT_MACRO_NAME "${_GEH_PREFIX_NAME}${BASE_NAME_UPPER}_EXPORT")
+  set(NO_EXPORT_MACRO_NAME "${_GEH_PREFIX_NAME}${BASE_NAME_UPPER}_NO_EXPORT")
+  set(EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/${BASE_NAME_LOWER}_export.h")
+  set(DEPRECATED_MACRO_NAME "${_GEH_PREFIX_NAME}${BASE_NAME_UPPER}_DEPRECATED")
+  set(STATIC_DEFINE "${_GEH_PREFIX_NAME}${BASE_NAME_UPPER}_STATIC_DEFINE")
+  set(NO_DEPRECATED_MACRO_NAME
+    "${_GEH_PREFIX_NAME}${BASE_NAME_UPPER}_NO_DEPRECATED")
+
+  if(_GEH_UNPARSED_ARGUMENTS)
+    message(FATAL_ERROR "Unknown keywords given to GENERATE_EXPORT_HEADER(): \"${_GEH_UNPARSED_ARGUMENTS}\"")
+  endif()
+
+  if(_GEH_EXPORT_MACRO_NAME)
+    set(EXPORT_MACRO_NAME ${_GEH_PREFIX_NAME}${_GEH_EXPORT_MACRO_NAME})
+  endif()
+  if(_GEH_EXPORT_FILE_NAME)
+    if(IS_ABSOLUTE ${_GEH_EXPORT_FILE_NAME})
+      set(EXPORT_FILE_NAME ${_GEH_EXPORT_FILE_NAME})
+    else()
+      set(EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/${_GEH_EXPORT_FILE_NAME}")
+    endif()
+  endif()
+  if(_GEH_DEPRECATED_MACRO_NAME)
+    set(DEPRECATED_MACRO_NAME ${_GEH_PREFIX_NAME}${_GEH_DEPRECATED_MACRO_NAME})
+  endif()
+  if(_GEH_NO_EXPORT_MACRO_NAME)
+    set(NO_EXPORT_MACRO_NAME ${_GEH_PREFIX_NAME}${_GEH_NO_EXPORT_MACRO_NAME})
+  endif()
+  if(_GEH_STATIC_DEFINE)
+    set(STATIC_DEFINE ${_GEH_PREFIX_NAME}${_GEH_STATIC_DEFINE})
+  endif()
+
+  if(_GEH_DEFINE_NO_DEPRECATED)
+    set(DEFINE_NO_DEPRECATED TRUE)
+  endif()
+
+  if(_GEH_NO_DEPRECATED_MACRO_NAME)
+    set(NO_DEPRECATED_MACRO_NAME
+      ${_GEH_PREFIX_NAME}${_GEH_NO_DEPRECATED_MACRO_NAME})
+  endif()
+
+  set(INCLUDE_GUARD_NAME "${EXPORT_MACRO_NAME}_H")
+
+  get_target_property(EXPORT_IMPORT_CONDITION ${TARGET_LIBRARY} DEFINE_SYMBOL)
+
+  if(NOT EXPORT_IMPORT_CONDITION)
+    set(EXPORT_IMPORT_CONDITION ${TARGET_LIBRARY}_EXPORTS)
+  endif()
+
+  configure_file("${_GENERATE_EXPORT_HEADER_MODULE_DIR}/exportheader.cmake.in"
+    "${EXPORT_FILE_NAME}" @ONLY)
+endmacro()
+
+function(GENERATE_EXPORT_HEADER TARGET_LIBRARY)
+  get_property(type TARGET ${TARGET_LIBRARY} PROPERTY TYPE)
+  if(${type} STREQUAL "MODULE")
+    message(WARNING "This macro should not be used with libraries of type MODULE")
+    return()
+  endif()
+  if(NOT ${type} STREQUAL "STATIC_LIBRARY" AND NOT ${type} STREQUAL "SHARED_LIBRARY")
+    message(WARNING "This macro can only be used with libraries")
+    return()
+  endif()
+  _test_compiler_hidden_visibility()
+  _test_compiler_has_deprecated()
+  _do_set_macro_values(${TARGET_LIBRARY})
+  _do_generate_export_header(${TARGET_LIBRARY} ${ARGN})
+endfunction()
+
+function(add_compiler_export_flags)
+
+  _test_compiler_hidden_visibility()
+  _test_compiler_has_deprecated()
+
+  if(NOT (USE_COMPILER_HIDDEN_VISIBILITY AND COMPILER_HAS_HIDDEN_VISIBILITY))
+    # Just return if there are no flags to add.
+    return()
+  endif()
+
+  set (EXTRA_FLAGS "-fvisibility=hidden")
+
+  if(COMPILER_HAS_HIDDEN_INLINE_VISIBILITY)
+    set (EXTRA_FLAGS "${EXTRA_FLAGS} -fvisibility-inlines-hidden")
+  endif()
+
+  # Either return the extra flags needed in the supplied argument, or to the
+  # CMAKE_CXX_FLAGS if no argument is supplied.
+  if(ARGV0)
+    set(${ARGV0} "${EXTRA_FLAGS}" PARENT_SCOPE)
+  else()
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_FLAGS}" PARENT_SCOPE)
+  endif()
+endfunction()
diff --git a/orocos_kdl/config/cmakemoduleslegacy/exportheader.cmake.in b/orocos_kdl/config/cmakemoduleslegacy/exportheader.cmake.in
new file mode 100644
index 0000000..80a879d
--- /dev/null
+++ b/orocos_kdl/config/cmakemoduleslegacy/exportheader.cmake.in
@@ -0,0 +1,35 @@
+
+#ifndef @INCLUDE_GUARD_NAME@
+#define @INCLUDE_GUARD_NAME@
+
+#ifdef @STATIC_DEFINE@
+#  define @EXPORT_MACRO_NAME@
+#  define @NO_EXPORT_MACRO_NAME@
+#else
+#  ifndef @EXPORT_MACRO_NAME@
+#    ifdef @EXPORT_IMPORT_CONDITION@
+        /* We are building this library */
+#      define @EXPORT_MACRO_NAME@ @DEFINE_EXPORT@
+#    else
+        /* We are using this library */
+#      define @EXPORT_MACRO_NAME@ @DEFINE_IMPORT@
+#    endif
+#  endif
+
+#  ifndef @NO_EXPORT_MACRO_NAME@
+#    define @NO_EXPORT_MACRO_NAME@ @DEFINE_NO_EXPORT@
+#  endif
+#endif
+
+#ifndef @DEPRECATED_MACRO_NAME@
+#  define @DEPRECATED_MACRO_NAME@ @DEFINE_DEPRECATED@
+#  define @DEPRECATED_MACRO_NAME@_EXPORT @EXPORT_MACRO_NAME@ @DEFINE_DEPRECATED@
+#  define @DEPRECATED_MACRO_NAME@_NO_EXPORT @NO_EXPORT_MACRO_NAME@ @DEFINE_DEPRECATED@
+#endif
+
+#cmakedefine01 DEFINE_NO_DEPRECATED
+#if DEFINE_NO_DEPRECATED
+# define @NO_DEPRECATED_MACRO_NAME@
+#endif
+
+#endif
diff --git a/orocos_kdl/examples/CMakeLists.txt b/orocos_kdl/examples/CMakeLists.txt
index 616a760..b2d69ce 100644
--- a/orocos_kdl/examples/CMakeLists.txt
+++ b/orocos_kdl/examples/CMakeLists.txt
@@ -1,5 +1,5 @@
 IF(ENABLE_EXAMPLES)
-INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${PROJ_SOURCE_DIR}/models)
+INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${PROJ_SOURCE_DIR}/models ${PROJ_BINARY_DIR}/src ${PROJ_BINARY_DIR}/models)
 
  add_executable(geometry geometry.cpp )
  TARGET_LINK_LIBRARIES(geometry orocos-kdl)
diff --git a/orocos_kdl/examples/geometry.cpp b/orocos_kdl/examples/geometry.cpp
index 141ff04..99f44ff 100644
--- a/orocos_kdl/examples/geometry.cpp
+++ b/orocos_kdl/examples/geometry.cpp
@@ -1,6 +1,9 @@
 #include <frames.hpp>
 #include <frames_io.hpp>
 
+#define _USE_MATH_DEFINES  // For MSVC
+#include <math.h>
+
 int main()
 {
 
diff --git a/orocos_kdl/examples/trajectory_example.cpp b/orocos_kdl/examples/trajectory_example.cpp
index 99908fe..7995c72 100644
--- a/orocos_kdl/examples/trajectory_example.cpp
+++ b/orocos_kdl/examples/trajectory_example.cpp
@@ -21,6 +21,9 @@
 #include <utilities/error.h>
 #include <trajectory_composite.hpp>
 
+#define _USE_MATH_DEFINES  // For MSVC
+#include <math.h>
+
 int main(int argc,char* argv[]) {
 	using namespace KDL;
 	// Create the trajectory:
diff --git a/orocos_kdl/models/CMakeLists.txt b/orocos_kdl/models/CMakeLists.txt
index de8a567..b4be7ed 100644
--- a/orocos_kdl/models/CMakeLists.txt
+++ b/orocos_kdl/models/CMakeLists.txt
@@ -1,18 +1,23 @@
 OPTION(BUILD_MODELS "Build models for some well known robots" FALSE)
 
 IF(BUILD_MODELS)
-  
+  INCLUDE(GenerateExportHeader)
+  ADD_COMPILER_EXPORT_FLAGS()
   ADD_LIBRARY(orocos-kdl-models SHARED puma560.cpp kukaLWR_DHnew.cpp) 
-  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src)
+  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${PROJ_BINARY_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})
   SET_TARGET_PROPERTIES( orocos-kdl-models PROPERTIES
     SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
     VERSION "${KDL_VERSION}"
     COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}"
-    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
+    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
+    DEFINE_SYMBOL OROCOS_KDL_MODELS_EXPORTS
+    LINKER_LANGUAGE CXX)
+  GENERATE_EXPORT_HEADER(orocos-kdl-models BASE_NAME KDL_MODELS EXPORT_FILE_NAME kdl_models_export.hpp)
   TARGET_LINK_LIBRARIES(orocos-kdl-models orocos-kdl)
   
   INSTALL_TARGETS( /lib orocos-kdl-models)
   INSTALL_FILES( /include/kdl FILES models.hpp)
+  INSTALL_FILES( /include/kdl FILES ${CMAKE_CURRENT_BINARY_DIR}/kdl_models_export.hpp)
 ENDIF(BUILD_MODELS)
 
 INCLUDE(CMakeDependentOption)
diff --git a/orocos_kdl/models/models.hpp b/orocos_kdl/models/models.hpp
index 90ed895..ab0519d 100644
--- a/orocos_kdl/models/models.hpp
+++ b/orocos_kdl/models/models.hpp
@@ -22,14 +22,16 @@
 #ifndef MODELS_HPP
 #define MODELS_HPP
 
+#include <kdl_models_export.hpp>
+
 namespace KDL{
 
 class Chain;
 
-Chain Puma560();
-Chain KukaLWR();
-Chain KukaLWRsegment();
-Chain KukaLWR_DHnew();
+KDL_MODELS_EXPORT Chain Puma560();
+KDL_MODELS_EXPORT Chain KukaLWR();
+KDL_MODELS_EXPORT Chain KukaLWRsegment();
+KDL_MODELS_EXPORT Chain KukaLWR_DHnew();
 
 }
 #endif
\ No newline at end of file
diff --git a/orocos_kdl/models/puma560.cpp b/orocos_kdl/models/puma560.cpp
index 6074428..b084ac6 100644
--- a/orocos_kdl/models/puma560.cpp
+++ b/orocos_kdl/models/puma560.cpp
@@ -22,6 +22,9 @@
 #include <chain.hpp>
 #include "models.hpp"
 
+#define _USE_MATH_DEFINES  // For MSVC
+#include <math.h>
+
 namespace KDL{
     Chain Puma560(){
         Chain puma560;
diff --git a/orocos_kdl/src/CMakeLists.txt b/orocos_kdl/src/CMakeLists.txt
index 813d918..6760cf9 100644
--- a/orocos_kdl/src/CMakeLists.txt
+++ b/orocos_kdl/src/CMakeLists.txt
@@ -1,21 +1,32 @@
+
+INCLUDE(GenerateExportHeader)
+
 FILE( GLOB KDL_SRCS [^.]*.cpp )
 FILE( GLOB KDL_HPPS [^.]*.hpp [^.]*.inl)
 
 FILE( GLOB UTIL_SRCS utilities/[^.]*.cpp utilities/[^.]*.cxx)
 FILE( GLOB UTIL_HPPS utilities/[^.]*.h utilities/[^.]*.hpp)
 
+ADD_COMPILER_EXPORT_FLAGS()
+
 ADD_LIBRARY(orocos-kdl SHARED ${KDL_SRCS} ${UTIL_SRCS})
 SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
   SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
   VERSION "${KDL_VERSION}"
   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}"
-  INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
+  INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
+  DEFINE_SYMBOL OROCOS_KDL_EXPORTS
+  LINKER_LANGUAGE CXX)
+GENERATE_EXPORT_HEADER(orocos-kdl BASE_NAME KDL EXPORT_FILE_NAME kdl_export.hpp)
+INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
+
 
 INSTALL_TARGETS( /lib orocos-kdl)
 
 # CMake 2.2:
 INSTALL_FILES( /include/kdl FILES ${KDL_HPPS})
 INSTALL_FILES( /include/kdl/utilities FILES ${UTIL_HPPS})
+INSTALL_FILES( /include/kdl FILES ${CMAKE_CURRENT_BINARY_DIR}/kdl_export.hpp)
 
 # Orocos convention:
 CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc @ONLY)
diff --git a/orocos_kdl/src/articulatedbodyinertia.hpp b/orocos_kdl/src/articulatedbodyinertia.hpp
index e2524a7..3e2504a 100644
--- a/orocos_kdl/src/articulatedbodyinertia.hpp
+++ b/orocos_kdl/src/articulatedbodyinertia.hpp
@@ -26,6 +26,7 @@
 
 #include "rotationalinertia.hpp"
 #include "rigidbodyinertia.hpp"
+#include "kdl_export.hpp"
 
 #include <Eigen/Core>
 
@@ -37,7 +38,7 @@ namespace KDL {
      *	The inertia is defined in a certain reference point and a certain reference base.
      *	The reference point does not have to coincide with the origin of the reference frame.
      */
-    class ArticulatedBodyInertia{
+    class KDL_EXPORT ArticulatedBodyInertia{
     public:
 
         /**
@@ -72,32 +73,32 @@ namespace KDL {
         /**
          * Scalar product: I_new = double * I_old
          */
-        friend ArticulatedBodyInertia operator*(double a,const ArticulatedBodyInertia& I);
+        KDL_EXPORT friend ArticulatedBodyInertia operator*(double a,const ArticulatedBodyInertia& I);
         /**
          * addition I: I_new = I_old1 + I_old2, make sure that I_old1
          * and I_old2 are expressed in the same reference frame/point,
          * otherwise the result is worth nothing
          */
-        friend ArticulatedBodyInertia operator+(const ArticulatedBodyInertia& Ia,const ArticulatedBodyInertia& Ib);
-        friend ArticulatedBodyInertia operator+(const ArticulatedBodyInertia& Ia,const RigidBodyInertia& Ib);
-        friend ArticulatedBodyInertia operator-(const ArticulatedBodyInertia& Ia,const ArticulatedBodyInertia& Ib);
-        friend ArticulatedBodyInertia operator-(const ArticulatedBodyInertia& Ia,const RigidBodyInertia& Ib);
+        KDL_EXPORT friend ArticulatedBodyInertia operator+(const ArticulatedBodyInertia& Ia,const ArticulatedBodyInertia& Ib);
+        KDL_EXPORT friend ArticulatedBodyInertia operator+(const ArticulatedBodyInertia& Ia,const RigidBodyInertia& Ib);
+        KDL_EXPORT friend ArticulatedBodyInertia operator-(const ArticulatedBodyInertia& Ia,const ArticulatedBodyInertia& Ib);
+        KDL_EXPORT friend ArticulatedBodyInertia operator-(const ArticulatedBodyInertia& Ia,const RigidBodyInertia& Ib);
 
         /**
          * calculate spatial momentum: h = I*v
          * make sure that the twist v and the inertia are expressed in the same reference frame/point
          */
-        friend Wrench operator*(const ArticulatedBodyInertia& I,const Twist& t);
+        KDL_EXPORT friend Wrench operator*(const ArticulatedBodyInertia& I,const Twist& t);
 
         /**
          * Coordinate system transform Ia = T_a_b*Ib with T_a_b the frame from a to b.
          */
-        friend ArticulatedBodyInertia operator*(const Frame& T,const ArticulatedBodyInertia& I);
+        KDL_EXPORT friend ArticulatedBodyInertia operator*(const Frame& T,const ArticulatedBodyInertia& I);
         /**
          * Reference frame orientation change Ia = R_a_b*Ib with R_a_b
          * the rotation of b expressed in a
          */
-        friend ArticulatedBodyInertia operator*(const Rotation& R,const ArticulatedBodyInertia& I);
+        KDL_EXPORT friend ArticulatedBodyInertia operator*(const Rotation& R,const ArticulatedBodyInertia& I);
 
         /**
          * Reference point change with v the vector from the old to
diff --git a/orocos_kdl/src/chain.hpp b/orocos_kdl/src/chain.hpp
index 5dcb862..bfc0bcc 100644
--- a/orocos_kdl/src/chain.hpp
+++ b/orocos_kdl/src/chain.hpp
@@ -23,6 +23,7 @@
 #define KDL_CHAIN_HPP
 
 #include "segment.hpp"
+#include "kdl_export.hpp"
 #include <string>
 
 namespace KDL {
@@ -32,7 +33,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class Chain {
+    class KDL_EXPORT Chain {
     private:
         int nrOfJoints;
         int nrOfSegments;
diff --git a/orocos_kdl/src/chaindynparam.hpp b/orocos_kdl/src/chaindynparam.hpp
index bac007c..5d24a5d 100644
--- a/orocos_kdl/src/chaindynparam.hpp
+++ b/orocos_kdl/src/chaindynparam.hpp
@@ -25,6 +25,7 @@
 #include "chainidsolver_recursive_newton_euler.hpp"
 #include "articulatedbodyinertia.hpp"
 #include "jntspaceinertiamatrix.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -43,7 +44,7 @@ namespace KDL {
      * (expressed in the segments reference frame) and the dynamical
      * parameters of the segments.
      */
-    class ChainDynParam
+    class KDL_EXPORT ChainDynParam
     {
     public:
         ChainDynParam(const Chain& chain, Vector _grav);
diff --git a/orocos_kdl/src/chainfksolver.hpp b/orocos_kdl/src/chainfksolver.hpp
index fa6f625..baebb92 100644
--- a/orocos_kdl/src/chainfksolver.hpp
+++ b/orocos_kdl/src/chainfksolver.hpp
@@ -28,6 +28,7 @@
 #include "jntarray.hpp"
 #include "jntarrayvel.hpp"
 #include "jntarrayacc.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -38,8 +39,7 @@ namespace KDL {
      * @ingroup KinematicFamily
      */
 
-    //Forward definition
-    class ChainFkSolverPos {
+    class KDL_EXPORT ChainFkSolverPos {
     public:
         /**
          * Calculate forward position kinematics for a KDL::Chain,
@@ -60,7 +60,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class ChainFkSolverVel {
+    class KDL_EXPORT ChainFkSolverVel {
     public:
         /**
          * Calculate forward position and velocity kinematics, from
@@ -83,7 +83,7 @@ namespace KDL {
      * @ingroup KinematicFamily
      */
 
-    class ChainFkSolverAcc {
+    class KDL_EXPORT ChainFkSolverAcc {
     public:
         /**
          * Calculate forward position, velocity and accelaration
@@ -98,7 +98,7 @@ namespace KDL {
          */
     virtual int JntToCart(const JntArrayAcc& q_in, FrameAcc& out,int segmentNr=-1)=0;
 
-        virtual ~ChainFkSolverAcc()=0;
+        virtual ~ChainFkSolverAcc(){};
     };
 
 
diff --git a/orocos_kdl/src/chainfksolverpos_recursive.hpp b/orocos_kdl/src/chainfksolverpos_recursive.hpp
index 72cdab0..8d8ecf8 100644
--- a/orocos_kdl/src/chainfksolverpos_recursive.hpp
+++ b/orocos_kdl/src/chainfksolverpos_recursive.hpp
@@ -23,6 +23,7 @@
 #define KDLCHAINFKSOLVERPOS_RECURSIVE_HPP
 
 #include "chainfksolver.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
@@ -33,7 +34,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class ChainFkSolverPos_recursive : public ChainFkSolverPos
+    class KDL_EXPORT ChainFkSolverPos_recursive : public ChainFkSolverPos
     {
     public:
         ChainFkSolverPos_recursive(const Chain& chain);
diff --git a/orocos_kdl/src/chainfksolvervel_recursive.hpp b/orocos_kdl/src/chainfksolvervel_recursive.hpp
index b6b58b8..26787a9 100644
--- a/orocos_kdl/src/chainfksolvervel_recursive.hpp
+++ b/orocos_kdl/src/chainfksolvervel_recursive.hpp
@@ -23,6 +23,7 @@
 #define KDL_CHAIN_FKSOLVERVEL_RECURSIVE_HPP
 
 #include "chainfksolver.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
@@ -34,7 +35,7 @@ namespace KDL
      *
      * @ingroup KinematicFamily
      */
-    class ChainFkSolverVel_recursive : public ChainFkSolverVel
+    class KDL_EXPORT ChainFkSolverVel_recursive : public ChainFkSolverVel
     {
     public:
         ChainFkSolverVel_recursive(const Chain& chain);
diff --git a/orocos_kdl/src/chainidsolver.hpp b/orocos_kdl/src/chainidsolver.hpp
index b7f4636..925fe69 100644
--- a/orocos_kdl/src/chainidsolver.hpp
+++ b/orocos_kdl/src/chainidsolver.hpp
@@ -25,6 +25,7 @@
 #include "chain.hpp"
 #include "frames.hpp"
 #include "jntarray.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
@@ -36,7 +37,7 @@ namespace KDL
 	 * dynamics solver for a KDL::Chain.
 	 *
 	 */
-	class ChainIdSolver
+	class KDL_EXPORT ChainIdSolver
 	{
 		public:
 			/** 
diff --git a/orocos_kdl/src/chainidsolver_recursive_newton_euler.hpp b/orocos_kdl/src/chainidsolver_recursive_newton_euler.hpp
index 3140cd2..89aae85 100644
--- a/orocos_kdl/src/chainidsolver_recursive_newton_euler.hpp
+++ b/orocos_kdl/src/chainidsolver_recursive_newton_euler.hpp
@@ -23,6 +23,7 @@
 #define KDL_CHAIN_IKSOLVER_RECURSIVE_NEWTON_EULER_HPP
 
 #include "chainidsolver.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL{
     /**
@@ -37,7 +38,7 @@ namespace KDL{
      * (expressed in the segments reference frame) and the dynamical
      * parameters of the segments.
      */
-    class ChainIdSolver_RNE : public ChainIdSolver{
+    class KDL_EXPORT ChainIdSolver_RNE : public ChainIdSolver{
     public:
         /**
          * Constructor for the solver, it will allocate all the necessary memory
diff --git a/orocos_kdl/src/chainidsolver_vereshchagin.hpp b/orocos_kdl/src/chainidsolver_vereshchagin.hpp
index 9038b25..84a9a31 100644
--- a/orocos_kdl/src/chainidsolver_vereshchagin.hpp
+++ b/orocos_kdl/src/chainidsolver_vereshchagin.hpp
@@ -25,6 +25,7 @@
 #include "chainidsolver.hpp"
 #include "frames.hpp"
 #include "articulatedbodyinertia.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
@@ -40,7 +41,7 @@ typedef Eigen::Matrix<double, 6, 1 > Vector6d;
 typedef Eigen::Matrix<double, 6, 6 > Matrix6d;
 typedef Eigen::Matrix<double, 6, Eigen::Dynamic> Matrix6Xd;
 
-class ChainIdSolver_Vereshchagin
+class KDL_EXPORT ChainIdSolver_Vereshchagin
 {
 public:
     /**
